Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.server
Class S_Category

    java.lang.Object
      oracle.ifs.server.S_LibraryObject
          oracle.ifs.server.S_TieLibraryObject
              oracle.ifs.server.S_PublicObject
                  oracle.ifs.server.S_TiePublicObject
                      oracle.ifs.server.S_Category

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, PublicObjectInterface, Traceable

Direct Known Subclasses:
  S_TieCategory

    public class S_Category

extends S_TiePublicObject

Category subclasses can contain their own custom data, which effectively contain data about the PublicObject with which the Category instance is associated.

A PublicObject can be associated with any Category, which allows different sets of data to be associated with instances of the same PublicObject subclass.

(Published)

Field Summary
`static int` | `POLICY_ENUM_CATEGORYCOPY_COPY`
`static int` | `POLICY_ENUM_CATEGORYCOPY_INVALID_VALUE`
`static int` | `POLICY_ENUM_CATEGORYCOPY_NOCOPY`

Fields inherited from class oracle.ifs.server.S_PublicObject
`ACL_ATTRIBUTE, CLASS_NAME, CREATEDATE_ATTRIBUTE, CREATOR_ATTRIBUTE, DELETOR_ATTRIBUTE, EXPIRATIONDATE_ATTRIBUTE, FAMILY_ATTRIBUTE, LASTMODIFIER_ATTRIBUTE, LASTMODIFYDATE_ATTRIBUTE, NAME_ATTRIBUTE, OWNER_ATTRIBUTE, POLICY_ENUM_EXTENDEDFREE_IGNORE_OWNERSHIP, POLICY_ENUM_EXTENDEDFREE_INVALID_VALUE, POLICY_ENUM_EXTENDEDFREE_REQUIRE_ADMIN, POLICYBUNDLE_ATTRIBUTE, RESOLVED_OBJECT_ATTRIBUTE, SECURINGPUBLICOBJECT_ATTRIBUTE`

Fields inherited from class oracle.ifs.server.S_LibraryObject
`CASCADE_OP_COPY_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_COPY_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_DELETE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_DELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_DELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_DELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_DELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_DELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_DELETE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_DELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_FREE_CATEGORY_TO_PUBLICOBJECT, CASCADE_OP_FREE_CATEGORY_TO_SCHEMAOBJECT, CASCADE_OP_FREE_CATEGORY_TO_SYSTEMOBJECT, CASCADE_OP_FREE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_FREE_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_FREE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_FREE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_FREE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_FREE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_FREE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_FREE_SCHEMAOBJECT_TO_CATEGORY, CASCADE_OP_FREE_SYSTEMOBJECT_TO_CATEGORY, CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_FREE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_FREE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_UNDEFINED, CASCADE_OP_UNDELETE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_UNDELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_UNDELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_UNDELETE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_UNDELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_UPDATE_CATEGORY_TO_PUBLICOBJECT, CASCADE_OP_UPDATE_CATEGORY_TO_SCHEMAOBJECT, CASCADE_OP_UPDATE_CATEGORY_TO_SYSTEMOBJECT, CASCADE_OP_UPDATE_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_UPDATE_SCHEMAOBJECT_TO_CATEGORY, CASCADE_OP_UPDATE_SYSTEMOBJECT_TO_CATEGORY, DEFAULT_RENDERER, m_ClassId, m_Id, m_Session`

Constructor Summary
`protected` | `S_Category(S_LibrarySession session, java.lang.Long classId)` Constructs a S_Category object.
`protected` | `S_Category(S_LibrarySession session, S_LibraryObjectData data)` Constructs a S_Category object - standard variant.

Method Summary
`protected void` | `cascadeFree(OperationState opState, S_LibraryObjectDefinition sdef)` Performs cascade operations prior to freeing the actual object.
`protected void` | `cascadeFreeToAssociatedObject(OperationState opState)` Notifies the Associated PublicObject of freeing action.
`protected void` | `cascadeUpdate(OperationState opState, S_LibraryObjectDefinition def)` cascade operations to be performed before updating an object.
`protected static S_Category[]` | `constructCategoryArray(S_LibrarySession sess, java.lang.Long[] ids)` Construct a Category array from an array of object IDs.
`protected void` | `deriveDefinition(S_LibraryObjectDefinition def)` Add to the S_LibraryObjectDefinition for this class.
`java.io.Serializable` | `DYNMoveCategory(java.io.Serializable payload)` Move Category to another PublicObject.
`protected void` | `extendedPostInsert(OperationState opState, S_LibraryObjectDefinition sdef)` Performs validation after to an insert.
`protected void` | `extendedPostUpdate(OperationState opState, S_LibraryObjectDefinition sdef)` Perform extended updates for Category.
`protected void` | `extendedPreInsert(OperationState opState, S_LibraryObjectDefinition sdef)` Update any system attributes appropriate for creating this object
`protected void` | `forceSecuredObjectsToClear(OperationState opState)` Overrides `forceSecuredObjectsToClear`, as there are never objects that reference this as their SecuringPublicObject.
`protected void` | `freeNonsharedAcl(OperationState opState)` Overrides `freeNonsharedAcl`, as we never need to free our ACL since it is always inherited from the associated PublicObject.
`S_PublicObject` | `getAssociatedPublicObject()` Gets the PublicObject associated with this Category.
`S_Folder` | `getAuditEventFolderContext()` Gets the folder context for the target of an Audit Event.
`protected void` | `handleCascade(OperationState opState, S_LibraryObject source, int cascadeType, S_LibraryObjectDefinition sdef, java.lang.Object customArg)` Handles a cascaded operation initiated by (usually) another object.
`protected void` | `propagateSecurityChanges(OperationState opState, S_LibraryObjectDefinition def)` Overrides `propagateSecurityChanges`, as there are never objects that reference this as their SecuringPublicObject.
`protected void` | `resolveACLSetting(S_LibraryObjectDefinition def)` Overrides `resolveACLSetting`, as we don't want to ever clone an ACL associated with a Category.

Methods inherited from class oracle.ifs.server.S_PublicObject
`addCategory, addRelationship, addRelationship, canUseContentQuota, cascadeCopy, cascadeDelete, cascadeUndelete, checkAccess, constructPublicObjectArray, createCategories, createDefaultPolicyPropertyBundle, createDefaultPropertyBundle, delete, delete, determineResolvedObject, DYNReplaceCreator, DYNReplaceDeletor, DYNReplaceModifier, extendedPostDelete, extendedPostFree, extendedPostUndelete, extendedPreCopy, extendedPreDelete, extendedPreFree, extendedPreUndelete, extendedPreUpdate, freeIfNoFolderReferences, freeNonsharedLockObject, getAcl, getAllFolderPaths, getAllFolderPaths, getAllFolderPaths, getAllFolderPaths, getAllLeftRelationships, getAllRightRelationships, getAnyFolderPath, getAnyFolderPath, getAnyFolderPath, getAnyFolderPath, getCategories, getCategories, getCategories, getCategory, getConsumedStorage, getDefaultAclFromUserProfile, getFamily, getFlags, getLeftRelationships, getLeftwardRelationshipDatas, getLeftwardRelationshipDatas, getLeftwardRelationshipObjectDatas, getLeftwardRelationshipObjectDatas, getLeftwardRelationshipObjects, getLeftwardRelationshipObjects, getLeftwardRelationships, getLeftwardRelationships, getLeftwardRelationshipsCount, getLeftwardRelationshipsCount, getLinkIds, getLinks, getLockedForSessionId, getLockObject, getOwner, getPrimaryParentFolder, getPropagatedSecurityAttributeNames, getPropagatedSecurityColumnNames, getReferencingFolderIds, getReferencingFolders, getResolvedObject, getRightRelationships, getRightwardRelationshipDatas, getRightwardRelationshipDatas, getRightwardRelationshipObjectDatas, getRightwardRelationshipObjectDatas, getRightwardRelationshipObjects, getRightwardRelationshipObjects, getRightwardRelationships, getRightwardRelationships, getSpecificLeftRelationships, getSpecificRightRelationships, getVersionDescriptions, handleExtendedFreePolicy, hasNameAttribute, invokeLockingPolicy, isAuditCertificateSecured, isDeleted, isLocked, isLockedForSession, isLockedForSessionByCurrentSession, isLockObjectEnabled, isLockObjectEnabled, isOwner, isVersionable, postCreateAddToFolder, postDelete, postSecurityChangeAuditEvent, postUndelete, preDelete, preUndelete, propagateFreeIfNoFolderReferences, propagateNameChanges, propogateSettingsToProxyService, putProperty, reassociateLinks, relationshipExists, removeRelationship, removeRelationship, removeRowFromAclProxyIfSecured, resolveResolvedObject, resolveSecuredBySettings, signalLeftRelationshipFreed, signalRightRelationshipFreed, undelete, undelete, unlockForSession, updateFamily, updateLastModifiedInfo, updatePrimaryParentFolder, vectorToSPublicObjectArray, verifyCanAddRelationship, verifyCanCreate, verifyCanFree, verifyCanLock, verifyCanRemoveRelationship, verifyCanSetPolicy, verifyCanUnlock, verifyCanUpdate, verifyCanUseContentQuota, verifyGrantAccess, verifyObjectNotLocked, verifyObjectNotLocked, verifyPublicObjectPermission`

Methods inherited from class oracle.ifs.server.S_LibraryObject
`applyValueDefault, associatedPostFree, associatedPostInsert, associatedPreInsert, checkRequiredForInsert, checkSettable, clearArrayTypeAttributeValues, clonePublicObjectAttribute, constructIdArray, constructIdArray, copy, copy, copyVectorToLibraryObjectArray, createInstance, deleteRows, deriveOwnerUniqueName, deriveOwnerUniqueName, deriveUppercasedAttribute, determineClassDomain, determinePolicy, determinePolicy, determineValueDefault, determineValueDomain, dispose, DYNLockRows, equals, executePolicyOperation, findPolicyFromPropertyBundleAv, free, free, getAttribute, getAttributeByUpperCaseName, getAuditCertificateName, getAuditDomainContext, getClassData, getClassId, getClassName, getClassObject, getData, getDefinition, getEffectivePolicyActionContexts, getEffectivePolicyListElements, getEventualAttributeByUpperCaseName, getId, getLibraryConnection, getName, getObjectReferenceAttribute, getPropertyBundle, getPropertyValue, getResourceString, getResourceString, getService, getSession, getSessionInterface, getTraceLogger, handleEvent, hashCode, insertReferenceAttributes, insertRow, insertRows, invalidateState, invokeOperation, invokePolicyMethod, isBroadcastCreateEventEnabled, isInstanceOf, issueCascade, isTraced, lockRows, postEvent, postEvent, postFree, postInsert, postUpdate, preFree, preInsert, preUpdate, renderAsReader, renderAsStream, setAttribute, setAttribute, setAttributes, toString, trace, update, updateRows, verifyCanGetContent, verifyCanSetContent, verifyWriteableTransactionInProgress`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getAttributeByUpperCaseName, getClassId, getId, getSessionInterface`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Field Detail

### POLICY_ENUM_CATEGORYCOPY_INVALID_VALUE

    public static final int POLICY_ENUM_CATEGORYCOPY_INVALID_VALUE

See Also:
  Constant Field Values
(Unpublished)

### POLICY_ENUM_CATEGORYCOPY_COPY

    public static final int POLICY_ENUM_CATEGORYCOPY_COPY

See Also:
  Constant Field Values
(Unpublished)

### POLICY_ENUM_CATEGORYCOPY_NOCOPY

    public static final int POLICY_ENUM_CATEGORYCOPY_NOCOPY

See Also:
  Constant Field Values
(Unpublished)

Constructor Detail

### S_Category

    protected S_Category(S_LibrarySession session,
                         S_LibraryObjectData data)
                  throws IfsException

  Constructs a S_Category object - standard variant.

  Parameters:
    `session` - current LibrarySession
    `data` - data component
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### S_Category

    protected S_Category(S_LibrarySession session,
                         java.lang.Long classId)
                  throws IfsException

  Constructs a S_Category object. This variant is used for objects that have not been created in the database yet.

  Parameters:
    `session` - current LibrarySession
    `classId` - class id
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

Method Detail

### getAssociatedPublicObject

    public S_PublicObject getAssociatedPublicObject()
                                             throws IfsException

  Description copied from class: `S_Category`
  Gets the PublicObject associated with this Category.

  Returns:
    the PublicObject
  Throws:
    `IfsException` - if operation fails
  (Published)

### deriveDefinition

    protected void deriveDefinition(S_LibraryObjectDefinition def)
                             throws IfsException

  Description copied from class: `S_Category`
  Add to the S_LibraryObjectDefinition for this class. This this called by getDefinition() on S_LibraryObject. This must call super.deriveDefinition() before applying any class-specific changes to the S_LibraryObjectDefinition object.

  Overrides:
    `deriveDefinition` in class `S_PublicObject`
  Parameters:
    `def` - the definition of the target object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### handleCascade

    protected void handleCascade(OperationState opState,
                                 S_LibraryObject source,
                                 int cascadeType,
                                 S_LibraryObjectDefinition sdef,
                                 java.lang.Object customArg)
                          throws IfsException

  Description copied from class: `S_Category`
  Handles a cascaded operation initiated by (usually) another object. This is overridden by classes to add custom handlers. It is ok if no class handles the cascade (that is implied to mean "no action needed").

  Overrides:
    `handleCascade` in class `S_PublicObject`
  Parameters:
    `opState` - originating operation state
    `source` - object initiating this cascade request (not necessarily the original object)
    `cascadeType` - type of cascade request
    `sdef` - original Definition object
    `customArg` - any custom parameter
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### cascadeFree

    protected void cascadeFree(OperationState opState,
                               S_LibraryObjectDefinition sdef)
                        throws IfsException

  Description copied from class: `S_Category`
  Performs cascade operations prior to freeing the actual object. This is overridden by classes that need to perform operations before successfully freeing the rows for the freed instance.

  Overrides:
    `cascadeFree` in class `S_PublicObject`
  Parameters:
    `opState` - current operation state
    `sdef` - definition object
  Throws:
    `IfsException` - if operation fails
  (Unpublished)

### cascadeUpdate

    protected void cascadeUpdate(OperationState opState,
                                 S_LibraryObjectDefinition def)
                          throws IfsException

  Description copied from class: `S_Category`
  cascade operations to be performed before updating an object. This is overridden by classes that need to perform operations before successfully updating the rows for the freed instance.

  Overrides:
    `cascadeUpdate` in class `S_LibraryObject`
  Parameters:
    `opState` - current operation state
    `def` - object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeFreeToAssociatedObject

    protected void cascadeFreeToAssociatedObject(OperationState opState)
                                          throws IfsException

  Description copied from class: `S_Category`
  Notifies the Associated PublicObject of freeing action.

  Parameters:
    `opState` - current operation state
  Throws:
    `IfsException` - if operation fails
  (Unpublished)

### extendedPreInsert

    protected void extendedPreInsert(OperationState opState,
                                     S_LibraryObjectDefinition sdef)
                              throws IfsException

  Description copied from class: `S_Category`
  Update any system attributes appropriate for creating this object

  Overrides:
    `extendedPreInsert` in class `S_PublicObject`
  Parameters:
    `opState` - current operation state
    `sdef` - current object definition to be updated with system attributes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### extendedPostInsert

    protected void extendedPostInsert(OperationState opState,
                                      S_LibraryObjectDefinition sdef)
                               throws IfsException

  Description copied from class: `S_Category`
  Performs validation after to an insert.

  Overrides:
    `extendedPostInsert` in class `S_PublicObject`
  Parameters:
    `opState` - current operation state
    `sdef` - the definition of the Property being created
  Throws:
    `IfsException` - (IFS-31600) if no values were specified
  (Published)

### extendedPostUpdate

    protected void extendedPostUpdate(OperationState opState,
                                      S_LibraryObjectDefinition sdef)
                               throws IfsException

  Description copied from class: `S_Category`
  Perform extended updates for Category.

  Overrides:
    `extendedPostUpdate` in class `S_PublicObject`
  Parameters:
    `opState` - the operation state
    `sdef` - current object definition
  Throws:
    `IfsException` - if the operation fails

### resolveACLSetting

    protected void resolveACLSetting(S_LibraryObjectDefinition def)
                              throws IfsException

  Description copied from class: `S_Category`
  Overrides `resolveACLSetting`, as we don't want to ever clone an ACL associated with a Category. This will always be set to the top associated object's ACL.

  Overrides:
    `resolveACLSetting` in class `S_PublicObject`
  Parameters:
    `def` - current object definition
  Throws:
    `IfsException` - if operation fails
  (Unpublished)

### forceSecuredObjectsToClear

    protected void forceSecuredObjectsToClear(OperationState opState)
                                       throws IfsException

  Description copied from class: `S_Category`
  Overrides `forceSecuredObjectsToClear`, as there are never objects that reference this as their SecuringPublicObject. Any nested categories are still secured by the top-most PublicObject.

  Overrides:
    `forceSecuredObjectsToClear` in class `S_PublicObject`
  Parameters:
    `opState` - current operation state
  Throws:
    `IfsException` - if operation fails
  (Unpublished)

### propagateSecurityChanges

    protected void propagateSecurityChanges(OperationState opState,
                                            S_LibraryObjectDefinition def)
                                     throws IfsException

  Description copied from class: `S_Category`
  Overrides `propagateSecurityChanges`, as there are never objects that reference this as their SecuringPublicObject. Any nested categories are still secured by the top-most PublicObject.

  Overrides:
    `propagateSecurityChanges` in class `S_PublicObject`
  Parameters:
    `opState` - current operation state
    `def` - Definition of security changes
  Throws:
    `IfsException` - if operation fails
  (Unpublished)

### freeNonsharedAcl

    protected void freeNonsharedAcl(OperationState opState)
                             throws IfsException

  Description copied from class: `S_Category`
  Overrides `freeNonsharedAcl`, as we never need to free our ACL since it is always inherited from the associated PublicObject.

  Overrides:
    `freeNonsharedAcl` in class `S_PublicObject`
  Parameters:
    `opState` - current operation state
  Throws:
    `IfsException` - if operation fails
  (Unpublished)

### DYNMoveCategory

    public java.io.Serializable DYNMoveCategory(java.io.Serializable payload)
                                         throws IfsException

  Description copied from class: `S_Category`
  Move Category to another PublicObject.

  Parameters:
    `payload` - the new target PublicObject (as an AttributeValue)
  Returns:
    nothing
  Throws:
    `IfsException` - if operation fails.

### constructCategoryArray

    protected static S_Category[] constructCategoryArray(S_LibrarySession sess,
                                                         java.lang.Long[] ids)
                                                  throws IfsException

  Description copied from class: `S_Category`
  Construct a Category array from an array of object IDs.

  Parameters:
    `sess` - the requesting session
    `ids` - the array of object IDs
  Returns:
    the array of Categorys
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getAuditEventFolderContext

    public S_Folder getAuditEventFolderContext()
                                        throws IfsException

  Description copied from class: `S_Category`
  Gets the folder context for the target of an Audit Event.

  Override to delegate to the associated PublicObject.

  Overrides:
    `getAuditEventFolderContext` in class `S_PublicObject`
  Returns:
    the folder context for the target
  Throws:
    `IfsException` - if the operation fails

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD